/*
**	$VER: AddProcmail.thor 1.2 (17.7.97)
**
**	 by Kenneth 'Kenny' Nilsen - Freeware
**	mailto:kenny@bgnett.no
**	http://www.bgnett.no/~kenny/
**
**	Add an entry to the .procmailrc file and upload to server.
**	Also initializes new header file if one don't already exists.
**	Must be invoked from Thor!
*/

/* Please modify the next variables */

/* Please enter the name on your email conference. When this is detected
*  the search routine is disabled. This is because, if you get a spam
*  email it is "guaranteed" not in the filterfile. However, I usually add
*  spam domains when I see them in newsgroups as well since they are likely
*  to end up in email too later. You cannot filter newsgroups therefor you
*  need to check if the entry already exists in the email filter to avoid
*  duplicates */

EmailConf = "EMail"

/* Next entry tells this script the path to where the .procmailrc
*  file exists. Change this to suit your system. The filename is not
*  needed since the script adds it automatically. You MUST end the path
*  with a column (:) or slash (/) */

ProcPath = "txt:.net/"

/* If you want to upload the .procmailrc file automatically from this
*  script you should set this bool to true (1) else set it to 0 if you
*  don't want to be asked if you want to upload the file. Script is
*  aborted at this stage if false. The script uses NComm to upload. */

Upload   = 1

/* Enter the phonebook entry name here if you have set the above
*  bool to true. The name must match exact the one you have in the
*  NComm phonebook. The phonebook entry should invoke an upload script
*  to login, upload and exit automatically. See provided example
*  script for NComm on how you can do it */

BBSEntry = "to update .procmailrc"

/* If you don't want this script to search for duplicates then set this
*  flag to 1 - search is only activated when adding from a newsgroup */

EmailFlag=0

/*----------------------------------------------------------------------
   Please don't modify below this text - if you know Procmail you
   may edit the entry datas. If you change the entry line length you
   must edit the search routine as well which is calibrated to four
   lines search - do not touch if you don't know what you're doing!
----------------------------------------------------------------------*/

options results

thorport = address()

LF='0a'x

if ~show('p', 'BBSREAD') then do
	address command
	"run >nil: `GetEnv THOR/THORPath`bin/LoadBBSRead"
	"WaitForPort BBSREAD"
	end

address(thorport)

CURRENTMSG stem MSG
if(rc ~= 0) then
do
	REQUESTNOTIFY TEXT '"No current message."' BT '"_Ok"'
	exit
	end

address(bbsread)

/* Read the header data of the message */

if upper(MSG.CONFNAME) = upper(EmailConf) then EmailFlag=1

READBRMESSAGE bbsname '"'MSG.BBSNAME'"' confname '"'MSG.CONFNAME'"' msgnr MSG.MSGNR headstem HEADTAGS textstem TEXTTAGS
if(rc ~= 0) then goto quit

fromd=HEADTAGS.FROMADDR

/* find and strip @ in address */

address(thorport)

cutpos=pos('@',fromd)
if cutpos=0 then do
	REQUESTNOTIFY TEXT '"'Could not find the @ char in domain...'"' BT '"_OK"'
	exit
	end	

if length(fromd)=1 then do
	REQUESTNOTIFY TEXT '"'Only a @ in email address!'"' BT '"_OK"'
	exit
	end

addDomain="*"||substr(fromd,cutpos+1,length(fromd)-cutpos)

/* create misc strings, for Thor and for file */

fromdt="** ^From.*"||addDomain
fromd="* ^From."||addDomain
thortxt="Add new entry in the '.procmailrc' file ?\n\n:0\n"fromdt"\n/dev/null\n"

/* check that there is a .procmailrc file - if not, create a header file */

file=procpath".procmailrc"

if ~exists(file) then do

	reqtxt="There is no .procmailrc file in path.\nCreate a new header file ?"
	REQUESTNOTIFY TEXT '"'reqtxt'"' BT '"_OK|_No"'
		if(rc=5) then exit 0
		if (result=0) then exit 0

	if(~open(fh,file,'W')) then do
		reqtxt="Could not open file for writing..."
		REQUESTNOTIFY TEXT '"'reqtxt'"' BT '"_OK"'
		exit 0
		end

	call writeln(fh,"PATH=/bin:/usr/bin:/opt/bin"||LF||"MAILDIR=$HOME/Mail"||LF||LF||"# This entry allows logging"||LF||LF||"LOGFILE=$HOME/log.procmail"||LF||LF||"# NOTE: You may have to change Mail to mail if the file"||LF||"# doesn't work correctly. Also check path."||LF||LF||"# Created by Kenneth 'Kenny' Nilsen"||LF||"# Domain names are provided by Petter Nilsen (700+)"||LF||"# Converted to .procmailrc format by Kenny@bgnett.no"||LF)
	call close(fh)
	EmailFlag=1	/* do not search since this is a new file */
end

/* inform user */

REQUESTNOTIFY TEXT '"'thortxt'"' BT '"_ADD|_Cancel"'
	if(rc=5) then exit 0
	if (result=0) then exit 0

/* check if entry already exists */

if EmailFlag=0 then do

	OpenProgress TITLE '"AddProcmail 1.2  by Kenny@bgnett.no"' AT '"_Abort"' PCW 56

if(rc~=0) then do
	reqtxt="Couldn't open Progressbar!"
	REQUESTNOTIFY TEXT '"'reqtxt'"' BT '"_OK"'
	exit
	end

window=result

	UpdateProgress REQ window TOTAL 100 CURRENT 1 PT '"Analyzing file..."'

	if(~open(fh,file,'R')) then do
		CloseProgress REQ window
		reqtxt="Could not open file for reading!"
		REQUESTNOTIFY TEXT '"'reqtxt'"' BT '"_OK"'
		exit 0
		end

	filelen=seek(fh,0,'e')
	if filelen=0 then do
		CloseProgress REQ window
		reqtxt="File is of length 0 - aborting!"
		REQUESTNOTIFY TEXT '"'reqtxt'"' BT '"_OK"'
		exit 0
		end

	call seek fh,0,'b'

	updatetxt="Searching for domain @"||addDomain
	UpdateProgress REQ window TOTAL '"'filelen'"' CURRENT 1 PT '"'updatetxt'"'

/* Find first entry of .procmailrc file - we assume it's made by AddProcmail.thor !
   That means there are four lines for each entry - modify if you have changed length
   of entry that this script creates per add */

	do while(~eof(fh))
		procline=readln(fh)
		curpos=seek(fh,0)
		UpdateProgress REQ window CURRENT '"'curpos'"'
		if procline=":0" then break
		end

/* do a "fast" search - read four lines at once, compare one time only */

	do while(~eof(fh))

		procline=readln(fh)
		curpos=seek(fh,0)
		UpdateProgress REQ window CURRENT '"'curpos'"'
		if (rc=5) then do
			CloseProgress REQ window
			call close(fh)
			reqtxt="Search aborted! Quitting.."
			REQUESTNOTIFY TEXT '"'reqtxt'"' BT '"_OK"'
			exit 0
			end

		dpos=pos(addDomain,procline)
		if (dpos~=0) then do
			CloseProgress REQ window
			call close(fh)
			reqtxt="Entry already exist in .procmailrc file!\nAdding aborted!"
			REQUESTNOTIFY TEXT '"'reqtxt'"' BT '"_OK"'
			exit 0
			end

		/* skip three lines of file */

		procline=readln(fh)
		procline=readln(fh)
		if (~eof(fh)) then procline=readln(fh)
	end

	call close(fh)
	CloseProgress REQ window

end

/* add entry to file */

if(~open(fh,file,'A')) then do
	reqtxt="Could not open file for writing..."
	REQUESTNOTIFY TEXT '"'reqtxt'"' BT '"_OK"'
	exit 0
	end

call writeln(fh,":0"||'0a'x||fromd||'0a'x||"/dev/null"||'0a'x)
call close(fh)

/* upload feature activated ? */

if upload=0 then exit

reqtxt="Upload '.procmailrc' file via NComm now ?"
REQUESTNOTIFY TEXT '"'reqtxt'"' BT '"_NO|_Upload"'
if(rc=5) then exit 0
if (result=1) then exit 0

/* yes, next is stolen code  :-P */

if ~show('p', 'ncomm') then do
	if ~exists("t:NCommStartupScript") then do
		call open(nscript, "t:NCommStartupScript", W)
		call writeln(nscript, "stack 10000")
		call writeln(nscript, "cd NComm:")
		call writeln(nscript, "run <>nil: NComm")
		call close(nscript)
	end

	address command
		"execute >nil: t:NCommStartupScript"
		"WaitForPort ncomm"
	if(rc) then exit
end

address 'ncomm'
NCOMMTOFRONT
DIAL bbsentry

Exit

quit:
	address(thorport)
	REQUESTNOTIFY TEXT '"'BBSREAD.LASTERROR'"' BT '"_Ok"'
	exit
